/* $Id: cfunc.tpl,v 1.1 91/03/18 19:01:04 bill Exp $ */
/*.......1.........2.........3.........4.........5.........6.........7.........8
================================================================================

FILE gain/cfunc.mod

Copyright 1991
Georgia Tech Research Corporation, Atlanta, Ga. 30332
All Rights Reserved

PROJECT A-8503-405
               

AUTHORS                      

    6 Jun 1991     Jeffrey P. Murray


MODIFICATIONS   

     2 Oct 1991    Jeffrey P. Murray
                                   

SUMMARY

    This file contains the model-specific routines used to
    functionally describe the gain code model.


INTERFACES       

    FILE                 ROUTINE CALLED     

    N/A                  N/A                     


REFERENCED FILES

    Inputs from and outputs to ARGS structure.
                     

NON-STANDARD FEATURES

    NONE

===============================================================================*/

/*=== INCLUDE FILES ====================*/
#include <math.h>

                                      

/*=== CONSTANTS ========================*/




/*=== MACROS ===========================*/



  
/*=== LOCAL VARIABLES & TYPEDEFS =======*/                         


    
           
/*=== FUNCTION PROTOTYPE DEFINITIONS ===*/




                   
/*==============================================================================

FUNCTION void cm_gain()

AUTHORS                      

     2 Oct 1991     Jeffrey P. Murray

MODIFICATIONS   

    NONE

SUMMARY

    This function implements the gain code model.

INTERFACES       

    FILE                 ROUTINE CALLED     

    N/A                  N/A


RETURNED VALUE
    
    Returns inputs and outputs via ARGS structure.

GLOBAL VARIABLES
    
    NONE

NON-STANDARD FEATURES

    NONE

==============================================================================*/


/*=== CM_GAIN ROUTINE ===*/
                                                   

void cm_linktest(ARGS)   /* structure holding parms, inputs, outputs, etc.     */
{

    double p1in, p1last, abs1, rel1;
    double p2in, p2last, abs2, rel2;
    
    if (INIT) {
	STATIC_VAR(last1) = 0;
	STATIC_VAR(last2) = 0;
    } else {
    
    if(ANALYSIS != MIF_AC) {
    }
    else {
    }
    
    // If last value is < cha, update when value differs for more than cha
    // If last value is > cha, update if relative change is larger than cha
    
    p1in = INPUT(p1);
    p2in = INPUT(p1);
    
    p1last = STATIC_VAR(last1);
    p2last = STATIC_VAR(last2);
    
    abs1 = PARAM(cha12);
    rel1 = PARAM(chp12);
    
    abs2 = PARAM(cha21);
    rel2 = PARAM(chp21);
    
    
        OUTPUT(p2) = p1in+p2in*1e-6;
        STATIC_VAR(last1) = p1in;
    
        OUTPUT(p1) = -p2in+p2in*1e-6;
        STATIC_VAR(last2) = p2in;
    
        
        PARTIAL(p1,p1) = 1e-6;
        PARTIAL(p2,p2) = 1e-6;
        PARTIAL(p1,p2) = 0;
        PARTIAL(p2,p1) = 0;
    }
    
    

}
